(*!
@file        ArCanMultipleSend.st
@brief       ʹArCANʵCAN֡ͨѶͳ
@date        ڣ2022.01.19; ޸ڣ2022.01.19;
@version     V 1.00.1
@author      ChenJianpu
@copyright   B&R
@LIMIT
*)
(*! History
 *****************************************************************************
 *     2022.01.19    V1.00.1   ChenJianpu
 *         (new)     湦                      
 ******************************************************************************
*)
PROGRAM _INIT
	ArCanSender.senderDeviceName := 'IF7';
	ArCanSender.ID := 16#FF;
	ArCanSender.multipleSend := 10;	
END_PROGRAM
	

PROGRAM _CYCLIC	
	
	CASE ArCanSender.step OF
		STEP_WAIT:
			(* wait for starting *)
	
			
		STEP_INIT_BAUDRATE: (* Initializes the sender with ArCanSetBaudrate to 250 kbit/s *)
			ArCanSender.ArCanSetBaudrate_0.Execute := TRUE;
			ArCanSender.ArCanSetBaudrate_0.DeviceName := ArCanSender.senderDeviceName;
			ArCanSender.ArCanSetBaudrate_0.Baudrate := 250000;		(* Set to 250 000 bit/s *)			
			
			ArCanSender.ArCanSetBaudrate_0();
			
			IF (ArCanSender.ArCanSetBaudrate_0.Done = TRUE) THEN
				ArCanSender.step := STEP_INIT_SENDER;
			ELSIF (ArCanSender.ArCanSetBaudrate_0.Error = TRUE) THEN
				ArCanSender.lastError := ArCanSender.ArCanSetBaudrate_0.StatusID;
				ArCanSender.errorCount := ArCanSender.errorCount + 1;
				ArCanSender.step := STEP_ERROR;
			END_IF;
			
			
		STEP_INIT_SENDER:	(* Initializes the CAN Sender *)	
			ArCanSender.ArCanSend_0.Enable := TRUE;
			ArCanSender.ArCanSend_0.DeviceName := ArCanSender.senderDeviceName;
			
			IF (ArCanSender.ArCanSend_0.Active = TRUE) THEN		(* Checks if the FB is active for configuring a sending CAN frame *)
				ArCanSender.step := STEP_INIT_SEND_FRAMES;
				ArCanSender.frameCount := ArCanSender.multipleSend;
			ELSIF (ArCanSender.ArCanSend_0.Error = TRUE) THEN				
				ArCanSender.errorCount := ArCanSender.errorCount + 1;
				ArCanSender.lastError := ArCanSender.ArCanSend_0.StatusID;
				ArCanSender.step := STEP_ERROR;
			END_IF;			

		
		STEP_INIT_SEND_FRAMES: (* Transmits CAN Frames *)	
			
			WHILE (ArCanSender.frameCount > 0) DO
	  
				IF (ArCanSender.ArCanSend_0.NumberOfFreeBuffers > 0) THEN
					ArCanSender.frameCount := ArCanSender.frameCount - 1;
					ArCanSender.iterationCounter := ArCanSender.iterationCounter + 1;
			
					memcpy( ADR(ArCanSender.ArCanSend_0.Frame.Data), ADR(ArCanSender.iterationCounter), SIZEOF(ArCanSender.iterationCounter));			
					ArCanSender.ArCanSend_0.Frame.DataLength := SIZEOF(ArCanSender.iterationCounter);
					ArCanSender.ArCanSend_0.Frame.ID := ArCanSender.ID;			
					ArCanSender.ArCanSend_0.Frame.Format := arCAN_11BIT;						
					ArCanSender.ArCanSend_0.SendFrame := TRUE;	(* Copies the frame into the internal buffer for sending it *)	
				
					ArCanSender.successCount := ArCanSender.successCount + 1; (* Frame is in the queue and will be sent *)
				ELSE
					ArCanSender.ArCanSend_0.SendFrame := FALSE;
					ArCanSender.waitCounter := ArCanSender.waitCounter  + 1; 
					EXIT; (* Interface has no more free internal buffers -> let continue the task *)
				END_IF;
				
				ArCanSender.ArCanSend_0();
								
				IF (ArCanSender.ArCanSend_0.Error = TRUE) THEN
					ArCanSender.lastError := ArCanSender.ArCanSend_0.StatusID;
					ArCanSender.errorCount := ArCanSender.errorCount + 1;				
					ArCanSender.step := STEP_ERROR;	
					EXIT;
				END_IF;					
				
			END_WHILE;	
			
			IF (ArCanSender.frameCount=0) THEN
	  			ArCanSender.step := STEP_DEINIT;
			END_IF;
			

			
		STEP_DEINIT:
			ArCanSender.ArCanSend_0.Enable := FALSE;
			ArCanSender.step := STEP_WAIT;
		
		 STEP_ERROR:
			ArCanSender.ArCanSend_0.Enable := FALSE;
	

	END_CASE;
	
	ArCanSender.ArCanSend_0();
	
END_PROGRAM


PROGRAM _EXIT
	(* Deinitialization of the sender *)
	ArCanSender.ArCanSend_0.Enable := FALSE;
	ArCanSender.ArCanSend_0();
END_PROGRAM
