(*!
@file        ArCanGetRtrData.st
@brief       ʹArCANʵCANԶ֡ճ
@date        ڣ2022.01.19; ޸ڣ2022.01.19;
@version     V 1.00.1
@author      ChenJianpu
@copyright   B&R
@LIMIT
*)
(*! History
 *****************************************************************************
 *     2022.01.19    V1.00.1   ChenJianpu
 *         (new)     湦                      
 ******************************************************************************
*)
PROGRAM _INIT
	CanGetRtrData.requestDeviceName 	:= 'SS1.IF1';
	CanGetRtrData.ID := 16#ff;
END_PROGRAM

PROGRAM _CYCLIC


	
	CASE CanGetRtrData.step OF
		STEP_WAIT:			
			(* wait for starting *)
					
		STEP_REQUEST_RTR:	(* Triggers a CAN RTR request *)
			CanGetRtrData.ArCanGetRtrData_0.Execute := NOT (CanGetRtrData.ArCanGetRtrData_0.Done);	(* FALSE -> TRUE triggers a new request with the following configuration *)
			CanGetRtrData.ArCanGetRtrData_0.DeviceName := CanGetRtrData.requestDeviceName;
			CanGetRtrData.ArCanGetRtrData_0.ID	:= CanGetRtrData.ID;
			CanGetRtrData.ArCanGetRtrData_0.Format	:= arCAN_11BIT;			
			CanGetRtrData.ArCanGetRtrData_0.ResponseDataLength := 0;	(* Data length is set by the responder *)
			CanGetRtrData.ArCanGetRtrData_0.Timeout := 2000;	(* timeout = 2s *)
					
			IF (CanGetRtrData.ArCanGetRtrData_0.Done = TRUE) THEN	(* Checks if the response was successfully received *)
				CanGetRtrData.successCount := CanGetRtrData.successCount + 1;
				memcpy( ADR(CanGetRtrData.receiveData), ADR(CanGetRtrData.ArCanGetRtrData_0.RtrFrame.Data) , CanGetRtrData.ArCanGetRtrData_0.RtrFrame.DataLength);
				CanGetRtrData.step := STEP_REQUEST_RTR; (* stay here to trigger a new request*)	
			ELSIF (CanGetRtrData.ArCanGetRtrData_0.Error = TRUE) THEN				
				CanGetRtrData.errorCount := CanGetRtrData.errorCount + 1;
				CanGetRtrData.lastRequestError := CanGetRtrData.ArCanGetRtrData_0.StatusID;				
				CanGetRtrData.step := STEP_ERROR;			
			END_IF;
			
			(* User stops the example *)
			IF (CanGetRtrData.stopTest = TRUE) THEN		
				CanGetRtrData.stopTest := FALSE;
				CanGetRtrData.step := STEP_WAIT;
				CanGetRtrData.ArCanGetRtrData_0.Execute := FALSE;		
			END_IF;	
								
		STEP_ERROR:
			CanGetRtrData.ArCanGetRtrData_0.Execute := FALSE;


	END_CASE;
	
	
	CanGetRtrData.ArCanGetRtrData_0();
	
END_PROGRAM



PROGRAM _EXIT
	CanGetRtrData.ArCanGetRtrData_0.Execute := FALSE;
	CanGetRtrData.ArCanGetRtrData_0();
END_PROGRAM
