(*!
@file        ArCanRtr.st
@brief       ʹArCANʵCANԶ֡ͳ
@date        ڣ2022.01.19; ޸ڣ2022.01.19;
@version     V 1.00.1
@author      ChenJianpu
@copyright   B&R
@LIMIT
*)
(*! History
 *****************************************************************************
 *     2022.01.19    V1.00.1   ChenJianpu
 *         (new)     湦                      
 ******************************************************************************
*)
PROGRAM _INIT
	CanRtr.responseDeviceName 	:= 'IF7';
	CanRtr.ID := 16#ff;	
END_PROGRAM

PROGRAM _CYCLIC
		
	 
	CASE CanRtr.step OF
		STEP_WAIT:
			(* wait for starting *)		
		
		STEP_INIT: (* Create a CAN RTR response instance *)
			CanRtr.ArCanRtr_0.Enable := TRUE;							(* Configuration of ID and Format, ... *)
			CanRtr.ArCanRtr_0.DeviceName := CanRtr.responseDeviceName;	(* ... which requires an Enable:=FLASE->TRUE *)
			CanRtr.ArCanRtr_0.ID := CanRtr.ID;
			CanRtr.ArCanRtr_0.Format := arCAN_11BIT;			
			
			IF (CanRtr.ArCanRtr_0.Active = TRUE) THEN		(* CAN RTR response instance creation finish *)
				CanRtr.step := STEP_CONFIGURE_RTR_RESPONSE;	(* and FUB is ready for updating the data *)
			ELSIF (CanRtr.ArCanRtr_0.Error = TRUE) THEN
				CanRtr.errorCount := CanRtr.errorCount + 1;
				CanRtr.lastResponseError := CanRtr.ArCanRtr_0.StatusID;
				CanRtr.step := STEP_ERROR;	
			END_IF;

			
		STEP_CONFIGURE_RTR_RESPONSE:	(* Updates the message for a CAN RTR request *)						
			memcpy( ADR(CanRtr.sendData), ADR(CanRtr.iterationCounter), SIZEOF(CanRtr.iterationCounter));	
			CanRtr.iterationCounter := CanRtr.iterationCounter + 1;
			
			(* Updates the response frame with new content & clears the ResponseSent output *)											
			CanRtr.ArCanRtr_0.DataLength := SIZEOF(CanRtr.iterationCounter);
			CanRtr.ArCanRtr_0.Data := CanRtr.sendData;
			CanRtr.ArCanRtr_0.SetData := TRUE;		(* Updates Data & DataLength - ValueSensitive *)
				
			CanRtr.step := STEP_WAIT_FOR_RESPONDING;	
			
			
		STEP_WAIT_FOR_RESPONDING:		(* Checks for error and for successful response *)
			CanRtr.ArCanRtr_0.SetData := FALSE;	
			
			IF (CanRtr.ArCanRtr_0.ResponseSent = TRUE) THEN
				CanRtr.successCount := CanRtr.successCount + 1;
				CanRtr.step := STEP_CONFIGURE_RTR_RESPONSE;
			ELSIF (CanRtr.ArCanRtr_0.Error = TRUE) THEN
				CanRtr.errorCount := CanRtr.errorCount + 1;
				CanRtr.lastResponseError := CanRtr.ArCanRtr_0.StatusID;
				CanRtr.step := STEP_ERROR;					
			END_IF;
			
			IF CanRtr.stopTest THEN
				CanRtr.stopTest := FALSE;
				CanRtr.step := STEP_DEINIT;
			END_IF;
			

								
		STEP_DEINIT: (* Deinitialization of ArCanRtr *)
			CanRtr.ArCanRtr_0.Enable := FALSE;
			CanRtr.step := STEP_WAIT;

		STEP_ERROR:
			CanRtr.ArCanRtr_0.Enable := FALSE;
		
		
	END_CASE;
	
	
	CanRtr.ArCanRtr_0();
	
END_PROGRAM



PROGRAM _EXIT
	CanRtr.ArCanRtr_0.Enable	:= FALSE;
	CanRtr.ArCanRtr_0();
END_PROGRAM
