(*!
@file        CAN_Lib_CAN_01.st
@brief       ʹCAN_LibʵCANһһͨѶ
@date        ڣ2022.01.06; ޸ڣ2022.01.06;
@version     V 1.00.1
@author      ChenJianpu
@copyright   B&R
@Limit
*)
(*! History
 *****************************************************************************
 *     2022.01.06    V1.00.1   ChenJianpu
 *         (new)     湦                      
 ******************************************************************************
*)

PROGRAM _INIT
	(* ʹʱ޸Ĳ *)
	canReadWrite.canDevice0 := 'IF7 /BD=500000 /EX=0';            //趨CAN1λ,,֡ʽ
	canReadWrite.canDevice1 := 'IF6.ST1.IF1 /BD=500000 /EX=0';    //趨CAN2λ,,֡ʽ
	MY_CAN_IDENTIFIER       := 16;  //CANıʶ
	
	
	canReadWrite.CANopen_0.enable  := TRUE;
	canReadWrite.CANopen_0.device  := ADR(canReadWrite.canDevice0);
	canReadWrite.CANopen_0.cob_anz := 100; //COB
	canReadWrite.CANopen_0.error_adr := canReadWrite.canError_0;
	canReadWrite.CANopen_0();
	
	canReadWrite.CANopen_1.enable  := TRUE;
	canReadWrite.CANopen_1.device  := ADR(canReadWrite.canDevice1);
	canReadWrite.CANopen_1.cob_anz := 100; //COB
	canReadWrite.CANopen_1.error_adr := canReadWrite.canError_1;
	canReadWrite.CANopen_1();
	
	canReadWrite.step := STEP_INIT;
END_PROGRAM

PROGRAM _CYCLIC
	(* Insert code here *)
	canReadWrite.CANinfo_0();   //ȡCAN1շ״̬
	canReadWrite.CANinfo_1();   //ȡCAN2շ״̬
	
	CASE canReadWrite.step OF
		STEP_INIT:
			IF canReadWrite.CANopen_0.status = 0 AND canReadWrite.CANopen_1.status = 0 THEN
				canReadWrite.CANinfo_0.enable   := TRUE;
				canReadWrite.CANinfo_0.info_adr := ADR(canReadWrite.canInfo_0);
				canReadWrite.CANinfo_0.us_ident := canReadWrite.CANopen_0.us_ident;
				
				canReadWrite.CANinfo_1.enable   := TRUE;
				canReadWrite.CANinfo_1.info_adr := ADR(canReadWrite.canInfo_1);
				canReadWrite.CANinfo_1.us_ident := canReadWrite.CANopen_1.us_ident;
				
				canReadWrite.step := STEP_PREPARE_READ;
			END_IF
			
		STEP_PREPARE_READ:
			canReadWrite.CANread_1.enable  := TRUE;       
			canReadWrite.CANread_1.us_ident := canReadWrite.CANopen_1.us_ident;  //ȡCAN2ڽ
			canReadWrite.CANread_1.can_id :=  MY_CAN_IDENTIFIER;
			canReadWrite.CANread_1.data_adr := ADR(canReadWrite.readData);
			canReadWrite.CANread_1();
			IF canReadWrite.CANread_1.status = canERR_NO_DATA THEN
				canReadWrite.step := STEP_WRITE;
			ELSE
				canReadWrite.step := STEP_ERROR;
			END_IF
		
		STEP_WRITE:
			canReadWrite.CANwrite_0.enable 	 := TRUE;
			canReadWrite.CANwrite_0.us_ident := canReadWrite.CANopen_0.us_ident; //CAN1ڷ
			canReadWrite.CANwrite_0.can_id   := MY_CAN_IDENTIFIER;
			canReadWrite.CANwrite_0.data_adr := ADR(canReadWrite.writeData);
			canReadWrite.CANwrite_0.data_lng := SIZEOF(canReadWrite.writeData);
			canReadWrite.CANwrite_0();
			IF canReadWrite.CANwrite_0.status = 0  THEN  //CANTimeܿڶȡCAN1ͨѶʱϢ
				canReadWrite.CANTime_0.enable := TRUE;
				canReadWrite.CANTime_0.us_ident := canReadWrite.CANopen_0.us_ident;
				canReadWrite.CANTime_0.can_id := MY_CAN_IDENTIFIER;
				canReadWrite.CANTime_0.pSystemTick := ADR(canReadWrite.writeTick);
		        canReadWrite.CANTime_0.pSystemStamp := ADR(canReadWrite.writeSystemStamp);
				canReadWrite.CANTime_0();
				
				canReadWrite.writeData[1] := canReadWrite.writeData[1] +1;
				canReadWrite.step := STEP_READ;
			ELSIF canReadWrite.CANwrite_0.status <> 1 THEN
				canReadWrite.step := STEP_ERROR;
			END_IF
				
		STEP_READ:		
			canReadWrite.CANread_1();
			IF canReadWrite.CANread_1.status = 0 THEN
				canReadWrite.CANTime_1.enable       := TRUE;
				canReadWrite.CANTime_1.us_ident     := canReadWrite.CANopen_1.us_ident;  //ڶȡCAN2ͨѶʱϢ
				canReadWrite.CANTime_1.can_id       := MY_CAN_IDENTIFIER;
				canReadWrite.CANTime_1.pSystemTick  := ADR(canReadWrite.readTick);
				canReadWrite.CANTime_1.pSystemStamp := ADR(canReadWrite.readSystemStamp);
				canReadWrite.CANTime_1();
				
				canReadWrite.diffTick := canReadWrite.readTick - canReadWrite.writeTick;
				canReadWrite.diffSystemStamp := canReadWrite.readSystemStamp - canReadWrite.writeSystemStamp;
				IF (canReadWrite.diffSystemStamp > canReadWrite.diffSystemStampMax) THEN
					canReadWrite.diffSystemStampMax := canReadWrite.diffSystemStamp;
				END_IF
				
				IF (canReadWrite.diffSystemStamp < canReadWrite.diffSystemStampMin) THEN
					canReadWrite.diffSystemStampMin := canReadWrite.diffSystemStamp;
				END_IF
					
				canReadWrite.successCount := canReadWrite.successCount +1;
				canReadWrite.writeData[0] := canReadWrite.successCount;
				canReadWrite.step := STEP_WRITE;
			ELSIF canReadWrite.CANread_1.status <> canERR_NO_DATA THEN
				canReadWrite.step := STEP_ERROR;
			END_IF
			
				
		STEP_ERROR:		
				
				
	END_CASE
	
	
END_PROGRAM

PROGRAM _EXIT
	(* Insert code here *)
	 
END_PROGRAM

