(*!
@file        Canxrd.st
@brief       ʹCAN_LibʵCANһһͨѶ
@date        ڣ2022.01.19; ޸ڣ2022.01.19;
@version     V 1.00.1
@author      ChenJianpu
@copyright   B&R
@LIMIT
*)
(*! History
 *****************************************************************************
 *     2022.01.19    V1.00.1   ChenJianpu
 *         (new)     湦                      
 ******************************************************************************
*)

PROGRAM	_INIT
	(* Initialize Names	and	ID's for the send program *)
	(* The device name for the CAN send	bus. One can find the name in the Physical View -> PLC Address. *)

	canXrd.CANopen_0.enable := TRUE;
	canXrd.CANopen_0.device := ADR('IF6.ST1.IF1 /BD=500000 /EX=0');
	canXrd.CANopen_0.cob_anz := 100;
	canXrd.CANopen_0.error_adr := ADR(canXrd.canError_0);
	canXrd.CANopen_0();
	
	canXrd.CANopen_1.enable := TRUE;
	canXrd.CANopen_1.device := ADR('IF7 /BD=500000 /EX=0');
	canXrd.CANopen_1.cob_anz := 100;
	canXrd.CANopen_1.error_adr := ADR (canXrd.canError_1);
	canXrd.CANopen_1();
	
END_PROGRAM

PROGRAM	_CYCLIC
	
	canXrd.CANinfo_0();
	canXrd.CANinfo_1();
	
	CASE canXrd.step OF
		
		STEP_INIT:	
			IF canXrd.CANopen_1.status = 0 AND canXrd.CANopen_0.status = 0 THEN
				canXrd.CANinfo_0.enable := TRUE;
				canXrd.CANinfo_0.info_adr := ADR(canXrd.canInfo_0);
				canXrd.CANinfo_0.us_ident := canXrd.CANopen_0.us_ident;

				canXrd.CANinfo_1.enable := TRUE;
				canXrd.CANinfo_1.info_adr := ADR(canXrd.canInfo_1);
				canXrd.CANinfo_1.us_ident := canXrd.CANopen_1.us_ident;

				canXrd.step := STEP_DEFINE_QUEUE;
			END_IF
			
		STEP_DEFINE_QUEUE:	
			canXrd.CANqueue_1.enable := TRUE;
			canXrd.CANqueue_1.us_ident := canXrd.CANopen_1.us_ident;
			(* 
			All received CAN packets are stored in the queue with the CAN identifier 0xFFFFFFFF. 
			In this CASE, all CAN identifiers are taken up. Because OF this, no more CAN packets 
			can be sent, AND no new CAN identifiers can be registered FOR receiving. 
			*)
			canXrd.CANqueue_1.can_id :=  16#FFFFFFFF;
			canXrd.CANqueue_1.size := 1000;
			canXrd.CANqueue_1();
			IF canXrd.CANqueue_1.status = 0 THEN
				canXrd.step := STEP_READ_QUEUE;
			END_IF
			
		STEP_QUICKWRITE:
			canXrd.CANquwr_0.enable := TRUE;
			canXrd.CANquwr_0.us_ident := canXrd.CANopen_0.us_ident;
			canXrd.CANquwr_0.data_adr := ADR(canXrd.writeData);
			canXrd.CANquwr_0.data_lng := SIZEOF (canXrd.writeData);
			
			FOR n:=0 TO MAX_SEND_FRAMES DO
				canXrd.CANquwr_0.can_id := MY_CAN_IDENTIFIER + n;
				canXrd.CANquwr_0();
				IF canXrd.CANquwr_0.status = 0 THEN
					canXrd.successWrite := canXrd.successWrite + 1;
					canXrd.writeData[0] := canXrd.successWrite;
				ELSIF canXrd.CANquwr_0.status <> canERR_CAN_QFULL THEN
					canXrd.step := STEP_ERROR;
					EXIT;
				END_IF
			END_FOR
			canXrd.step := STEP_READ_QUEUE;

		STEP_READ_QUEUE:
			canXrd.CANxrd_1.enable := TRUE;
			canXrd.CANxrd_1.q_ident := canXrd.CANqueue_1.q_ident;
			canXrd.CANxrd_1.data_adr := ADR(canXrd.readData);
			canXrd.CANxrd_1();
			WHILE canXrd.CANxrd_1.status = 0 DO    
				canXrd.successRead := canXrd.successRead + 1;
				canXrd.writeData[1] := canXrd.successRead;
				canXrd.CANxrd_1();
			END_WHILE;
			
			canXrd.step := STEP_QUICKWRITE;
			
		STEP_ERROR:	(* Error Handling *)
	END_CASE
END_PROGRAM

PROGRAM	_EXIT
END_PROGRAM


