(*!
@file        CanMulOpen.st
@brief       ʹCAN_LibʵCANһԶͨѶ
@date        ڣ2022.01.19; ޸ڣ2022.01.19;
@version     V 1.00.1
@author      ChenJianpu
@copyright   B&R
@LIMIT
*)
(*! History
 *****************************************************************************
 *     2022.01.19    V1.00.1   ChenJianpu
 *         (new)     湦                      
 ******************************************************************************
*)
PROGRAM	_INIT
	(* Initialize Names	and	ID's for the send program *)
	(* The device name for the CAN send	bus. One can find the name in the Physical View -> PLC Address. *)
	canMulOpen.mulDevParam[0].pDevice := ADR('SS1.IF1 /BD=500000 /EX=0');   //CANڽ
	canMulOpen.mulDevParam[1].pDevice := ADR('IF6.ST1.IF1 /BD=500000 /EX=0');
	canMulOpen.CANopen_0.device := ADR('IF7 /BD=500000 /EX=0');   ////һCANڷ
	
	FOR i := 0 TO ((SIZEOF (canMulOpen.mulDevParam))/SIZEOF (canMulOpen.mulDevParam[0]) - 1)  BY 1 DO
		canMulOpen.mulDevParam[i].cob_nr := 100;
		canMulOpen.mulDevParam[i].pError := ADR(canMulOpen.mulCanError[i]);
	END_FOR	
	canMulOpen.CANMulopen_0.enable := TRUE;
	canMulOpen.CANMulopen_0.pDevParam := ADR(canMulOpen.mulDevParam);
	canMulOpen.CANMulopen_0.dev_nr:= SIZEOF (canMulOpen.mulDevParam)/SIZEOF (canMulOpen.mulDevParam[0]);
	canMulOpen.CANMulopen_0();
	
	
	canMulOpen.CANopen_0.enable := TRUE;
	canMulOpen.CANopen_0.cob_anz := 100;
	canMulOpen.CANopen_0.error_adr := ADR(canMulOpen.canError_0);
	canMulOpen.CANopen_0();
END_PROGRAM

PROGRAM	_CYCLIC
	
	CASE canMulOpen.step OF
		
		STEP_INIT:	
			IF canMulOpen.CANMulopen_0.status = 0 AND canMulOpen.CANopen_0.status = 0 THEN
				canMulOpen.step := STEP_PREPARE_READ;
			END_IF
			
		STEP_PREPARE_READ:
			canMulOpen.CANread_0.enable  := TRUE;       
			canMulOpen.CANread_0.us_ident := canMulOpen.CANMulopen_0.us_ident;  //ȡCAN2ڽ
			canMulOpen.CANread_0.can_id :=  MY_CAN_IDENTIFIER;
			canMulOpen.CANread_0.data_adr := ADR(canMulOpen.readData);
			canMulOpen.CANread_0();
			IF canMulOpen.CANread_0.status = canERR_NO_DATA THEN
				canMulOpen.step := STEP_WRITE;
			ELSE
				canMulOpen.step := STEP_ERROR;
			END_IF
			
			
		STEP_WRITE:  //һCANڷ
			canMulOpen.CANwrite_0.enable := TRUE;
			canMulOpen.CANwrite_0.us_ident := canMulOpen.CANopen_0.us_ident;
			canMulOpen.CANwrite_0.can_id   := MY_CAN_IDENTIFIER;
			canMulOpen.CANwrite_0.data_adr := ADR(canMulOpen.writeData);
			canMulOpen.CANwrite_0.data_lng := SIZEOF (canMulOpen.writeData);
			canMulOpen.CANwrite_0();
			IF canMulOpen.CANwrite_0.status = 0  THEN  
				canMulOpen.writeData[0] := canMulOpen.writeData[0] +1;
				canMulOpen.writeData[1] := canMulOpen.writeData[1] +2;
				canMulOpen.successWrite := canMulOpen.successWrite +1;
				canMulOpen.step := STEP_READ;
			ELSIF canMulOpen.CANwrite_0.status <> 1 THEN
				canMulOpen.step := STEP_ERROR;
			END_IF
		
		STEP_READ:	//CANڽ
			canMulOpen.CANread_0();
			IF canMulOpen.CANread_0.status = 0 THEN
				canMulOpen.step := STEP_WRITE;
			ELSIF canMulOpen.CANread_0.status <> canERR_NO_DATA THEN
				canMulOpen.step := STEP_ERROR;
			END_IF
			
			
		STEP_ERROR:	(* Error Handling *)
		
	END_CASE
END_PROGRAM

PROGRAM	_EXIT
END_PROGRAM


